lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    # TODO Add friends path using friend_list Views
    path('friends', friend_list, name = "friend list")
]

lab_2/urls.py
from django.urls import path
from .views import index, xml, json

urlpatterns = [
    path('', index, name='index'),
    path('xml', xml, name='xml'),
    path('json', json, name='json')
]

lab_3/urls.py
from django.urls import path
from .views import index, add_friend

urlpatterns = [
    path('', index, name='index'),
    path('add', add_friend, name='add')
]

lab_4/urls.py
from django.urls import path
from .views import index, add_note, note_list

app_name = "lab-4"
urlpatterns = [
    path('', index, name='index'),
    path('add-note', add_note, name='add note'),
    path('note-list', note_list, name="note list")
]

lab_5/urls.py
from django.urls import path
from .views import index

app_name = "lab-5"
urlpatterns = [
    path('', index, name='index'),
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
from lab_1.views import index as index_lab1

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include('lab_1.urls')),
    path('lab-2/', include('lab_2.urls')),
    path('lab-3/', include('lab_3.urls')),
    path('lab-4/', include('lab_4.urls')),
    path('lab-5/', include('lab_5.urls')),
    re_path(r'^$', index_lab1, name='index')
]

lab_1/models.py
from django.db import models

# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    # TODO Implement missing attributes in Friend model
    npm = models.IntegerField()
    dob = models.DateField()

lab_2/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    to = models.CharField(max_length=30)
    from_v = models.CharField(max_length=30)
    title = models.CharField(max_length=30)
    message = models.CharField(max_length=100)

lab_3/models.py
from django.db import models

# Create your models here.

lab_4/models.py
from django.db import models

# Create your models here.

lab_5/models.py
from django.db import models

# Create your models here.

lab_3/forms.py
from lab_1.models import Friend
from django import forms

class FriendForm(forms.ModelForm):
    class Meta:
        model = Friend
        fields = ['name', 'npm', 'dob']
        error_messages = {'required' : 'Please enter every form'}
        name_attrs = {'type' : 'text', 'placeholder' : 'Friend name'}
        npm_attrs = {'type' : 'text', 'placeholder' : 'NPM'}
        dob_attrs = {'type' : 'text', 'placeholder' : 'Date of Birth'}
        name = forms.CharField(label='Nama', required=True, max_length=30)
        npm = forms.IntegerField(label='NPM', required=True)
        dob = forms.DateField(label='Date of Birth', required=True)

lab_4/forms.py
from django import forms
from lab_2.models import Note

class NoteForm(forms.ModelForm):
    class Meta:
        model = Note
        fields = ['to', 'from_v', 'title', 'message']
        error_messages = {'required' : 'Please enter every form'}
        widgets = {
            "message": forms.Textarea
        }
        # to = forms.CharField(label='To', required=True, max_length=30)
        # from_v = forms.CharField(label='From', required=True, max_length=30)
        # title = forms.CharField(label='Title', required=True, max_length=30)
        # message = forms.CharField(widget=forms.Textarea)

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Farel Musyaffa Arya Putra Majesta'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2002, 7, 19)  # TODO Implement this, format (Year, Month, Date)
npm = 2006596472  # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all().values() # TODO Implement this
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.shortcuts import render
from .models import Note
from django.http.response import HttpResponse
from django.core import serializers

# Create your views here.

def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab2.html', response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")

lab_3/views.py
from django.shortcuts import render
from lab_1.models import Friend
from .forms import FriendForm
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required

# Create your views here.
@login_required(login_url='/admin/login/')
def index(request):
    friends = Friend.objects.all().values() # TODO Implement this
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)

@login_required(login_url='/admin/login/')
def add_friend(request):
    context = {}
    form = FriendForm(request.POST or None, request.FILES or None)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            return HttpResponseRedirect("/lab-3")

    context['form'] = form
    return render(request, "lab3_form.html", context)

lab_4/views.py
from django.shortcuts import render
from lab_2.models import Note
from .forms import NoteForm
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required

# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab4_index.html', response)

def add_note(request):
    context = {}
    form = NoteForm(request.POST or None, request.FILES or None)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            return HttpResponseRedirect("/lab-4")

    context['form'] = form
    return render(request, "lab4_form.html", context)

def note_list(request):
    notes = Note.objects.all().values()
    response = {'notes' : notes}
    return render(request, 'lab4_note_list.html', response)

lab_5/views.py
from django.shortcuts import render
from lab_2.models import Note

# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab5_index.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      <!-- EXAMPLE SECTION -->
      {% if friends %} 
        {% for friend in friends %}
        <tr>
          <td>{{friend.name}}</td>
          <td>{{friend.npm}}</td>
          <td>{{friend.dob}}</td>
        </tr>
        {% endfor %}
      {% endif %}
      
       
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Note</title>
  </head>
  <style>
      table, th, td {
          border: 1px solid black;
      }
  </style>
  <body>
    <table style="width:100%">
      <tr>
        <th style="width:10%">To:</th>
        <th style="width:10%">From:</th>
        <th style="width:20%">Title:</th>
        <th style="width:100%">Message:</th>
      </tr>
      {% if notes %}
        {% for note in notes %}
        <tr>
          <td>{{note.to}}</td>
          <td>{{note.from_v}}</td>
          <td>{{note.title}}</td>
          <td>{{note.message}}</td>
        </tr>
        {% endfor %}
        {% endif %}
    </table>
  </body>
</html>

lab_3/templates/lab3_form.html
<form action="" method="POST">
    {% csrf_token %}
    {{form.as_p}}

    <input type = "submit" value = "Submit">
    
</form>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <style>
    table, th, td {
        border: 1px solid black;
    }
</style>
  <body>
    <table >
      <tr>
        <th style="width:20%">Name</th>
        <th style="width:20%">NPM</th>
        <th style="width:20%">DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      <!-- EXAMPLE SECTION -->
      {% if friends %} 
        {% for friend in friends %}
        <tr>
          <td>{{friend.name}}</td>
          <td>{{friend.npm}}</td>
          <td>{{friend.dob}}</td>
        </tr>
        {% endfor %}
      {% endif %}
      
       
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_4/templates/lab4_form.html
<head>
    <meta charset="UTF-8" />
    <title>Notes - Add Form</title>
</head>
<body>
    <h1>Notes - Add Form</h1>
</body>
<form action="" method="POST">
    {% csrf_token %}
    <div class="fieldWrapper">
        <label for="{{ form.to.id_for_label}}">
            To          :
        </label>
        {{form.to}}
    </div>
    <div class="fieldWrapper">
        <label for="{{ form.from_v.id_for_label}}">
            From        :
        </label>
        {{form.from_v}}
    </div>
    <div class="fieldWrapper">
        <label for="{{ form.title.id_for_label}}">
            Title       :
        </label>
        {{form.title}}
    </div>
    <div class="fieldWrapper">
        <label for="{{ form.message.id_for_label}}">
            Message     :   
        </label>
        {{form.message}}
    </div>

    <input type = "submit" value = "Submit" style="margin:10px;">
    
</form>
<style>
    h1 {
    color:black;
    }
    table {
        border:solid 1px black;background-color:white;width:100%;border-radius:5px;
    }
    th {
        background-color:black;color:white;width:50%; 
    }
    td {
        border:solid 1px black;
    }
    body {
        background-color:white;
    }
    .card {
        box-shadow: 0 0 4px 1px black;
        width: 40%;
        border-radius: 5px;
        margin:10px;
    }
    .container {
        padding: 2px 16px;
    }
    footer {
        box-shadow: 0 0 4px 1px black;
        margin:10px;
        padding:10px;
        display:inline-block;
    }
    .fieldWrapper {
        margin:10px;
    }
</style>
<footer>
    <a href="{% url 'lab-4:index' %}">INDEX</a>
    <span> | </span>
    <a href="{% url 'lab-4:note list' %}">NOTE LIST</a>
    <span> | </span>
    <a href="{% url 'lab-4:add note' %}">ADD NOTE</a>
</footer>

lab_4/templates/lab4_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes - Table Format</title>
    <link rel="stylesheet" href="{% url 'lab-4:index' %}" type="text/css">
    <!--Saya coba pakai external css, tapi hasilnya entah kenapa beda dengan kalau pakai internal css-->
  </head>
  <style>
    h1 {
    color:black;
    }
    table {
        border:solid 1px black;width:100%;border-radius:5px;padding:2px;background: linear-gradient(to bottom, #33ccff 0%, #ff99cc 100%);
    }
    th {
        width:50%; 
    }
    td {
        border:solid 1px black;background-color: white;
        border-radius: 5px;
    }
    body {
        background-color:white;
    }
    .card {
        box-shadow: 0 0 4px 1px black;
        width: 40%;
        border-radius: 5px;
        margin:10px;
    }
    .container {
        padding: 2px 16px;
    }
    footer {
        box-shadow: 0 0 4px 1px black;
        background: linear-gradient(to bottom, #33ccff 0%, #ff99cc 100%);
        margin:10px;
        padding:10px;
        display:inline-block;
    }
    .fieldWrapper {
        margin:10px;
    }
  </style>
  <body>
    <h1>Notes - Table Format</h1>
    <table>
      <tr>
        <th style="width:10%">To:</th>
        <th style="width:10%">From:</th>
        <th style="width:20%">Title:</th>
        <th style="width:100%">Message:</th>
      </tr>
      {% if notes %}
        {% for note in notes %}
        <tr>
          <td>{{note.to}}</td>
          <td>{{note.from_v}}</td>
          <td>{{note.title}}</td>
          <td>{{note.message}}</td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
  <footer>
    <a href="{% url 'lab-4:index' %}">INDEX</a>
    <span> | </span>
    <a href="{% url 'lab-4:note list' %}">NOTE LIST</a>
    <span> | </span>
    <a href="{% url 'lab-4:add note' %}">ADD NOTE</a>
</footer>
</html>

lab_4/templates/lab4_note_list.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes - Card Format</title>
    <!--link rel="stylesheet" href="D:\COOLIAH\SEMESTER 3\Pemrograman Berbasis Platform\GitLab PBP\pbp-lab\lab_4\templates\style.css" type="text/css"
    Saya coba pakai external css, tapi hasilnya entah kenapa beda dengan kalau pakai internal css-->
  </head>
  <style>
    h1 {
    color:black;
    }
    table {
        border:solid 1px black;background-color:white;width:100%;border-radius:5px;
    }
    th {
        background-color:black;color:white;width:50%; 
    }
    td {
        border:solid 1px black;
    }
    body {
        background-color:white;
    }
    .card {
        box-shadow: 0 0 4px 1px black;
        width: 40%;
        border-radius: 5px;
        margin:10px;
    }
    .container {
        padding: 2px 16px;
    }
    footer {
        box-shadow: 0 0 4px 1px black;
        margin:10px;
        padding:10px;
        display:inline-block;
    }
    .fieldWrapper {
        margin:10px;
    }
  </style>
  <!--Card format credit : https://www.w3schools.com/howto/howto_css_cards.asp-->
  <body>
    <h1>Notes - Card Format</h1>
    {% if notes %}
        {% for note in notes %}
        <div class="card">
            <div class="container">
                <h2>{{note.title}}</h2>
                <h5>To : {{note.to}}</h5>
                <h5>From : {{note.from_v}}</h5>
                <hr>
                <p>{{note.message}}</p>
            </div>
        </div>
        {% endfor %}
    {% endif %}
  </body>
  <footer>
      <a href="{% url 'lab-4:index' %}">INDEX</a>
      <span> | </span>
      <a href="{% url 'lab-4:note list' %}">NOTE LIST</a>
      <span> | </span>
      <a href="{% url 'lab-4:add note' %}">ADD NOTE</a>
  </footer>
</html>

lab_5/templates/lab5_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes - Table Format</title>
    <link rel="stylesheet" href="{% url 'lab-4:index' %}" type="text/css">
    <!--Saya coba pakai external css, tapi hasilnya entah kenapa beda dengan kalau pakai internal css-->
  </head>
  <!-- <style>
    h1 {
    color:black;
    }
    table {
        border:solid 1px black;width:100%;border-radius:5px;padding:2px;background: linear-gradient(to bottom, #33ccff 0%, #ff99cc 100%);
    }
    th {
        width:50%; 
    }
    td {
        border:solid 1px black;background-color: white;
        border-radius: 5px;
    }
    body {
        background-color:white;
    }
    .card {
        box-shadow: 0 0 4px 1px black;
        width: 40%;
        border-radius: 5px;
        margin:10px;
    }
    .container {
        padding: 2px 16px;
    }
    footer {
        box-shadow: 0 0 4px 1px black;
        background: linear-gradient(to bottom, #33ccff 0%, #ff99cc 100%);
        margin:10px;
        padding:10px;
        display:inline-block;
    }
    .fieldWrapper {
        margin:10px;
    }
  </style> -->
  <body>
    <h1>Notes - Table Format</h1>
    <table>
      <tr>
        <th style="width:10%">To:</th>
        <th style="width:10%">From:</th>
        <th style="width:20%">Title:</th>
        <th style="width:100%">Message:</th>
      </tr>
      {% if notes %}
        {% for note in notes %}
        <tr>
          <td>{{note.to}}</td>
          <td>{{note.from_v}}</td>
          <td>{{note.title}}</td>
          <td>{{note.message}}</td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
  <footer>
    <a href="{% url 'lab-4:index' %}">INDEX</a>
    <span> | </span>
    <a href="{% url 'lab-4:note list' %}">NOTE LIST</a>
    <span> | </span>
    <a href="{% url 'lab-4:add note' %}">ADD NOTE</a>
</footer>
</html>